unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, IBConnection, sqldb, db, FileUtil, Forms, Controls,
  Graphics, Dialogs, DbCtrls, DBGrids, ExtCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    IBConnection1: TIBConnection;
    Panel1: TPanel;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  // Firebird 2.5
  IBConnection1.CharSet      := 'UTF8';
  IBConnection1.DatabaseName :=  GetCurrentDir + '\SampleData.fdb';
  IBConnection1.HostName     := '127.0.0.1/3050';
  IBConnection1.Password     := 'masterkey';
  IBConnection1.Transaction  := SQLTransaction1;
  IBConnection1.UserName     := 'SYSDBA';
  IBConnection1.Open;

  SQLTransaction1.DataBase := IBConnection1;

  SQLQuery1.DataBase    := IBConnection1;
  SQLQuery1.SQL.Text    := 'Select * From MasterTable';
  SQLQuery1.ReadOnly    := True;
  SQLQuery1.Transaction := SQLTransaction1;

  DataSource1.DataSet     := SQLQuery1;
  DBNavigator1.DataSource := DataSource1;
  DBGrid1.DataSource      := DataSource1;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  SQLQuery1.Close;
  SQLQuery1.Open;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  Panel1.Caption := '';
  Panel1.Align   := alTop;
  SQLQuery1.Open;

  DBNavigator1.Align      := alTop;
  DBNavigator1.DataSource := DataSource1;
  DBNavigator1.Visible    := True;

  DBGrid1.Align            := alClient;
  DBGrid1.Columns[0].Width := 20;
  DBGrid1.Columns[1].Width := 200;
  DBGrid1.DataSource       := DataSource1;
  DBGrid1.Visible          := True;
  DBGrid1.SetFocus;
end;

end.

